<?php
/***************************************************************************
                          Etiko software
                             -------------------
    developement         : 2001-200x by Etikweb
    email                : webmaster@etikweb.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

include_once("./lib/forms.php");

// Line below is title
//* Calculadora de Nutrientes do Centro Vegetariano

define("FILE_","./util/tabela_nutrientes.csv");

define("CALCULATE","Calcular");
define("CHOOSE","Seleccione");

define("DDR","DDR");

define("GRAMS","Gramas");
define("GOOD","Alimento");
define("GOODS","Alimentos");

define("NUTRIENT_CALCULATOR","Calculadora de Nutrientes");
define("NUTRIENT_CALCULATOR_MESSAGE","Compara o valor nutritivo dos alimentos vegetais com os de origem animal. Verifica que a <b>alimentao vegetariana pode ser mais nutritiva e ter melhor qualidade</b>!<br /><br />
Escolhe os alimentos e quantidades, e o resultado aparece abaixo.<br />
Elimina alimentos indicando zero na quantidade.<br /><br />
O facto de no aparecer algum nutriente pode significar que o alimento em causa no o tem em quantidade significativa, ou que est omisso na tabela.
");
define("NUTRIENTS","Nutrientes");


define("TELL_ABOUT_NUTRIENT_COUNTER","Enviar endereo desta calculadora");
define("SEE_NUTRIENT_TABLE","Ver tabela de nutrientes completa (pdf)");

define("UNITS","Unidades");


function show_nutrient_select($name,$quant_name,$def_good,$def_quant){

  $lines=file(FILE_); // Open file

  echo "<b>".QUANT."</b> (".GRAMS."): "; show_text("text","$quant_name",4,$def_quant);

  echo "&nbsp;<b>".GOOD.":</b>"; 
  echo "\n<select name=\"$name\" OnChange='submit()'>\n";
  echo "<option value=\"0\">".CHOOSE."</option>\n";

  $counter=1;

  foreach ($lines as $line_num => $line) {
    if($line[0]=='#' || 
       (strncmp($line,NUTRIENTS,strlen(NUTRIENTS))==0) || 
       (strncmp($line,UNITS,strlen(UNITS))==0) || 
       (strncmp($line,DDR,strlen(DDR))==0) ) continue; // Skip comments

    $strings=explode(";",$line);
    if($strings[0]=="") continue; // "white" line

    if($line[0]=='*'){
      echo "<option value=\"----<b>$strings[0]</b>----\" disabled><b>$strings[0]*</b></option>\n";
//      echo "<optgroup label=\"$strings[0]\">TEST DDDDDDDD</optgroup>\n";

      continue; // Skip comments
      }

    if($def_good==$counter) echo "<option selected value=\"$counter\">$strings[0]</option>\n";
      else echo "<option value=\"$counter\">$strings[0]</option>\n";

    $counter++;
//    echo " $strings[0]:$strings[1]:$strings[2] <br />\n";

    }
    echo "</select>";
  }


function show_form($goods,$quants){

  echo "<h1>".NUTRIENT_CALCULATOR."</h1>";
  br();
  echo NUTRIENT_CALCULATOR_MESSAGE;

  begin_form();

  echo "<input type=\"hidden\" name=\"destin\" value=\"nutrient_table\">";
  echo "<input type=\"hidden\" name=\"op\" value=\"submit\">";

  br(); br();

  $counter=0;
  $total=-1;
  if($goods==true){

    foreach($goods as $good){
//echo "*counter=$counter++good=$good-.....";
      $total++; // count one more element

      if($quants[$counter]==false || $good==0) continue;

      show_nutrient_select("goods[$counter]","quants[$counter]",$good,$quants[$total]);
      br();
      $counter++; // number of elements in present form
      }
    }

//  if($price_per_litre==false) $price_per_litre=1.9;

//($name,$quant_name,$def_good,$def_quant){

  show_nutrient_select("goods[$counter]","quants[$counter]",0,100);

  br();
  end_form("send",CALCULATE);
  br();
  br();
  }



function sum_nutrients(&$total,$good,$quant){

  $lines=file(FILE_); // Open file

  $good_counter=0;

  foreach ($lines as $line_num => $line) {
    if($line[0]=='#' || 
       $line[0]=='*' || 
       (strncmp($line,NUTRIENTS,strlen(NUTRIENTS))==0) || 
       (strncmp($line,UNITS,strlen(UNITS))==0) || 
       (strncmp($line,DDR,strlen(DDR))==0) ) continue; // Skip comments

    $strings=explode(";",$line);
    if($strings[0]=="") continue; // "empty" line

    $good_counter++;

    if($good!=$good_counter) continue; // Doesn't matter

//    echo "Summing: $strings[0] --- $good,$good_counter";

    $counter=0;
    br(); br();
    foreach($strings as $string){
      if(is_numeric(trim($string))==true) $total[$counter]+=$quant*$string/100;
//      echo "$total[$counter] ; ";
      $counter++;
      }
//    echo " $strings[0]:$strings[1]:$strings[2] <br />\n";
    }
  }


function show_nutrients($names,$units,$values,$ddr){

  $names=explode(";",$names);
  $units=explode(";",$units);
  $ddr=explode(";",$ddr);

  $counter=0;
//    echo " $names <br />\n";

  foreach ($names as $name) {
    $counter++;
    if($counter<3) continue; // "white" line

    $index=$counter-1;
    if ($values[$index]>0){
      show_bold($name);
      echo ": $values[$index] $units[$index]";
      if($ddr[$index]>0){
        $percent=round($values[$index]/$ddr[$index]*100,2);
        show_small(" ($percent% DDR)");
        }

      br();
      }
    }
  }



function show_result($goods,$quants){
  global $site_url;

  echo "<h1>".RESULT."</h1>";

  $lines=file(FILE_); // Open file

  foreach ($lines as $line_num => $line) {

    if(strncmp($line,NUTRIENTS,strlen(NUTRIENTS))==0){ // Detect nutrients' name line
      $nutrient_name=$line;
      break;
      }
    }

  foreach ($lines as $line_num => $line) {
    if(strncmp($line,UNITS,strlen(UNITS))==0){ // Detect nutrients' unit line
      $nutrient_units=$line;
      break;
      }
    }
  foreach ($lines as $line_num => $line) {
    if(strncmp($line,DDR,strlen(DDR))==0){ // Detect DDR
      $ddr=$line;
      break;
      }
    }


//  br(); br();

  $counter=0;
  $strings=explode(";",$line);
  $total=array_fill(0,count($strings),0); // Start table with zeros
//  echo "TOTAL: $total";

  foreach($goods as $good){ // For all the elements 
    if($quants[$counter]==false || $good==0) continue;
    sum_nutrients($total,$good,$quants[$counter]); // Sume nutrients to table
    $counter++; // number of elements in present form
    }

  show_nutrients($nutrient_name,$nutrient_units,$total,$ddr);

  br(); br();

  foreach ($lines as $line_num => $line) {
    if($line[0]=='#'){ // Detect nutrients' unit line
      $strings = explode(";",$line);
      foreach($strings as $string)
       if($string!="" && $string!="#")
           echo $string; br();
      }
    }

  br(); br();

  echo TELL_ABOUT_NUTRIENT_COUNTER.": ";
  show_url_title("./index.php?destin=submit&amp;user_id=-1&amp;subject=".NUTRIENT_CALCULATOR."&amp;comments=$site_url/Nutrientes.html",SEND_FRIEND,SEND);
  br();
  echo SEE_NUTRIENT_TABLE.": ";
  show_url_title("./index.php?file_id=11",SEE_NUTRIENT_TABLE,HERE);

  br(); br();
  br(); br();

  }





function parse_op(){
  global $op,$site_prefix,$db,$goods,$quants,$send;

  show_form($goods,$quants);

//echo "-----------------$vegetarian_since--------***$age***";
  if($send==true  || $goods==true) show_result($goods,$quants);
  }


parse_op();


?>
